/***********************************************************************************************************
 * Une classe représentant une Led connectée sur une pin arduino
 * 
 *  IUT GEII TOULON - Correction du TP n° 2
 *  M.GRIMALDI - Octobre 2020
 *  
 */
 
#ifndef _LED_H
#define _LED_H

//La classe Led représente une led connectée sur une pin d'une carte arduino
class Led {
  private:
    //L'attribut state représente l'état de la led (true=allumée, false=éteinte)
    bool state;

    //l'attribut pin représentele numéro de la pin Arduino sur laquelle la led est branchée
    int pin;

    //L'attribut oneLogic décrit le mode de cablage (allumage par un niveau haut ou par un niveau bas)
    //oneLogic = true si allumage niveau haut
    bool oneLogic;


  public:
  // acesseurs getter/setter
    int get_pin();
    bool get_state() ;
    void set_pin(int value);
    void set_oneLogic(bool value);

    //constructeur par défaut: pin = -1 (non dééinie), state=false (éteinte), oneLogic=true (allumage sur niveau HIGH)
    Led();

    //constructeur:  pin =numéro de la pin Arduino, , oneLogic= type de logique de commande (high ou low)
    Led(int pin, bool oneLogic = true);

    //allume la led
    void lightOn();

    //éteind la led
     void lightOff();

    //inverse l'état de la led
     void invert();

    //allume la led pendant ms millisecondes puis l'éteind - si elle est déjà allumée, ne fait rien
     void flash(int ms = 100);


  private:
    //cette méthode revoie si le n° passé en argument pin est valide comme n° de pin ou pas (à reprendre en fonction du type de carte: nano, uno, .etc.)
    bool validPin(int);

};

#endif
