/***********************************************************************************************************
 * programme de test de la classe Led
 * 
 *  IUT GEII TOULON - Correction du TP n° 2
 *  M.GRIMALDI - Octobre 2020
 *  
 */

#include "Led.h"         
#include "Feu.h"

// instanciation de 6 objets de la classe Led
Led ledR(2, false);       // pin4, allumage niveau bas
Led ledV(4, true);        // pin2, allumage niveau haut
Led ledO(3, true);        // pin3, allumage niveau haut

Led ledR2(5, false);      // pin4, allumage niveau bas
Led ledV2(6, false);      // pin2, allumage niveau bas
Led ledO2(7, true);       // pin3, allumage niveau haut

// instanciation de 2 objets de la classe Feu
Feu f1(ledV, ledO, ledR);               // un feu de signalisation
Feu f2(ledV2, ledO2, ledR2);            // un feu de signalisation

//-----------------------------------------------------------------------------------------------------------------------------
void setup() {
    Serial.begin(9600);
    
    f1.set_duration(4000, 1000, 4000);   // durées des allumages
    f1.set_mode(MODE_AUTO);              // mode automatique

    f2.set_duration(4300, 500, 6000);   // durées des allumages
    f2.set_mode(MODE_AUTO);              // mode automatique
}


//-----------------------------------------------------------------------------------------------------------------------------
void loop() {
if (Serial.available()){                      // un caractère prêt  
          char c = Serial.read();             // on le lit
          switch (c){
                  case 'A': f1.set_mode(MODE_MANUEL); break;
                  case 'B': f1.set_mode(MODE_AUTO); break;
                  case 'C': f1.set_mode(MODE_ORANGE_CLI);break;
                  
                  case 'D': f2.set_mode(MODE_MANUEL); break;
                  case 'E': f2.set_mode(MODE_AUTO); break;
                  case 'F': f2.set_mode(MODE_ORANGE_CLI);break;
                  }
          }        
// mise à jour des deux Feu        
f1.sync();
f2.sync();
}

//-----------------------------------------------------------------------------------------------------------------------------
